#include "widget.h"
#include "ui_widget.h"
#include<QDebug>
#include<QDesktopWidget>
#include<QMouseEvent>
#include<QMessageBox>
#include<QTextCodec>
#include<windows.h>
#include<QPalette>
#include<QFile>
#include<QIODevice>
#include<QSettings>
#include<QShortcut>
#include<QMenu>
#include<QAction>


Widget::Widget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Widget)
{
    ui->setupUi(this);
    QTextCodec::setCodecForTr(QTextCodec::codecForName("gbk"));



    setWindowFlags(Qt::FramelessWindowHint);
    setWindowFlags(windowFlags() | Qt::Tool);

    setWindowFlags(windowFlags() | Qt::WindowStaysOnTopHint);//ö



    connect(ui->closelabel,SIGNAL(clicked()),this,SLOT(close()));
    connect(ui->TransparenthorizontalSlider,SIGNAL(valueChanged(int)),this,SLOT(settransparent(int)));
    connect(ui->textEdit->document(),SIGNAL(contentsChanged()),this,SLOT(textChanged()));
    connect(ui->topLabel,SIGNAL(clicked()),this,SLOT(topClicked()));
    ScreenWidth=QApplication::desktop()->width();
    ScreenHeight=QApplication::desktop()->height();
    WidgetWidth=geometry().width();
    WidgetHeight=geometry().height();
    startX=ScreenWidth/2-WidgetWidth/2;
    startY=0;

    setGeometry(startX,startY,WidgetWidth,WidgetHeight);



    QPalette palette;
    palette.setBrush(backgroundRole(),QBrush(QColor(248,247,182)));
    setPalette(palette);
    ui->TransparenthorizontalSlider->setValue(80);

    QFile file("note.txt");
    if(!file.open(QIODevice::ReadWrite))
    {
        ui->textEdit->append(tr("ʼǶȡʧܡ"));
    }
    QTextStream in(&file);

    QString note=in.readAll();
    qDebug()<<note;
    ui->textEdit->setText(note);

    color="yellow";

    QSettings setting("SoftWare Inc","yidianqingxin.com");
    int transNum=setting.value("transNum").toInt();
    ui->TransparenthorizontalSlider->setValue(transNum);
    color=setting.value("color").toString();
    if(color=="pink")
        setcolorPink();
    if(color=="white")
        setcolorWhite();
    if(color=="green")
        setcolorGreen();
    if(color=="yellow")
        setcolorYellow();




createACtion();

    //ui->textEdit->setContextMenuPolicy(Qt::CustomContextMenu);//ΪдĲ˵


}
void Widget::topClicked()
{
    if(geometry().height()>26)
    {
        TopTempWidth=geometry().width();
        TopTempHeight=geometry().height();
        setFixedSize(geometry().width(),26);
        ui->TransparenthorizontalSlider->hide();
        ui->topLabel->setText(tr("չ"));


    }
    else if(geometry().height()<=26)
    {
        setFixedSize(TopTempWidth,TopTempHeight);
        ui->topLabel->setText(tr("ʼ"));
        ui->TransparenthorizontalSlider->show();
    }

}

void Widget::createACtion()
{
    GreenAction=new QAction(tr("  ɫ"),this);
    connect(GreenAction,SIGNAL(triggered()),this,SLOT(setcolorGreen()));
    WhiteAction=new QAction(tr("  ɫ"),this);
    connect(WhiteAction,SIGNAL(triggered()),this,SLOT(setcolorWhite()));
    YellowAction=new QAction(tr("  ɫ"),this);
    connect(YellowAction,SIGNAL(triggered()),this,SLOT(setcolorYellow()));
    PinkAction=new QAction(tr("  ۺ"),this);
    connect(PinkAction,SIGNAL(triggered()),this,SLOT(setcolorPink()));

}

void Widget::contextMenuEvent(QContextMenuEvent *)
{
    QMenu *contextmenu=new QMenu(this);
    contextmenu->addAction(GreenAction);
    contextmenu->addAction(WhiteAction);
    contextmenu->addAction(YellowAction);
    contextmenu->addAction(PinkAction);
    contextmenu->exec(QCursor::pos());

}



void Widget::setcolorGreen()
{
    qDebug()<<"setcolorGreen";
    color="green";

    QPalette palette;
    palette.setBrush(backgroundRole(),QBrush(QColor(197,247,193)));
    setPalette(palette);
    ui->textEdit->setStyleSheet("background-color: rgb(208, 253, 202);");

    qDebug()<<geometry().x()+geometry().width()-10-16;
}
void Widget::setcolorPink()
{
    color="pink";
    QPalette palette;
    palette.setBrush(backgroundRole(),QBrush(QColor(241,195,241)));
    setPalette(palette);
    ui->textEdit->setStyleSheet("background-color: rgb(243,203 , 243);");
}
void Widget::setcolorWhite()
{
    color="white";
    QPalette palette;
    palette.setBrush(backgroundRole(),QBrush(QColor(240,240,240)));
    setPalette(palette);
    ui->textEdit->setStyleSheet("background-color: rgb(254, 254, 254);");
}
void Widget::setcolorYellow()
{
    color="yellow";
    QPalette palette;
    palette.setBrush(backgroundRole(),QBrush(QColor(248,247,182)));
    setPalette(palette);
    ui->textEdit->setStyleSheet("background-color: rgb(252, 250, 175);");
}



void Widget::textChanged()
{
    QTextDocument *document=qobject_cast<QTextDocument*>(sender());
    if(document)
    {
        int newheight=document->size().rheight();
        int newwidth=document->size().rwidth();
        //qDebug()<<newheight;

        //qDebug()<<"newheight="<<newheight;

        if(newheight>211)
        {
            setFixedHeight(newheight+19);

            //qDebug()<<230+newheight-ui->textEdit->height();
            ui->textEdit->setFixedHeight(newheight);
        }
        if(ui->textEdit->height()>newheight && ui->textEdit->height()>211)
        {
            setFixedHeight(230);
            ui->textEdit->setFixedHeight(211);
        }
       // qDebug()<<"newwidth="<<newwidth;

        if(newwidth>232)
        {
            setFixedWidth(newwidth);
            ui->textEdit->setFixedWidth(newwidth);
        }


        if(newwidth<232)
        {
           // qDebug()<<"newwidth<232";
            setFixedWidth(232);
            ui->textEdit->setFixedWidth(232);

        }

        ui->closelabel->setGeometry(geometry().width()-16,5,16,19);
        ui->TransparenthorizontalSlider->setGeometry(geometry().width()/2-ui->TransparenthorizontalSlider->width()/2,5,100,20);



    }
}

void Widget::settransparent(int transNum)
{
    double num=transNum/100.0;
    //qDebug()<<num;
    setWindowOpacity(num);
}




void Widget::closeEvent(QCloseEvent *event)
{
    QFile::remove("note.txt");

    QString Str=ui->textEdit->toHtml();
    qDebug()<<Str;
    QFile file("note.txt");
    if(!file.open(QIODevice::ReadWrite))
    {
        ui->textEdit->append(tr("ʼǴ洢ʧܡ"));
    }
    QTextStream out(&file);
    out<<Str<<endl;

    QSettings setting("SoftWare Inc","yidianqingxin.com");
    setting.setValue("transNum",ui->TransparenthorizontalSlider->value());
    setting.setValue("color",color);




    int r=QMessageBox::warning(this,tr("ʼ"),tr("ȷҪ˳ʼ"),QMessageBox::Yes,QMessageBox::No);
    if(r==QMessageBox::Yes)
    {
        qApp->quit();
    }
    else
    {
        event->ignore();
    }
}


void Widget::mouseReleaseEvent(QMouseEvent *event)
{
    if (event->button() == Qt::LeftButton)
    {
        dragPosition = QPoint(-1, -1);
        event->accept();
    }
}
void Widget::mousePressEvent(QMouseEvent *event)
{
    if (event->button() == Qt::LeftButton)
    {
        dragPosition = event->globalPos() - frameGeometry().topLeft();
        event->accept();
    }
}
void Widget::mouseMoveEvent(QMouseEvent *event)
{


    if (event->buttons() &Qt::LeftButton)
    {
        if (dragPosition != QPoint(-1, -1))
            move(event->globalPos() - dragPosition);
        event->accept();
    }


}

Widget::~Widget()
{
    delete ui;
}

//void Widget::on_textEdit_customContextMenuRequested(const QPoint &pos)
//{

//    QMenu *contextmenu=new QMenu(this);
//    contextmenu->addAction(GreenAction);
//    contextmenu->addAction(WhiteAction);
//    contextmenu->addAction(YellowAction);
//    contextmenu->addAction(PinkAction);
//    contextmenu->exec(QCursor::pos());
//    qDebug()<<pos.x();

//}
