#ifndef WIDGET_H
#define WIDGET_H

#include <QWidget>
#include<QAction>

namespace Ui {
class Widget;
}

class Widget : public QWidget
{
    Q_OBJECT
    
public:
    explicit Widget(QWidget *parent = 0);
    ~Widget();
    
private:
    Ui::Widget *ui;

    void mouseMoveEvent(QMouseEvent*event);
    void mousePressEvent(QMouseEvent*event);
    void mouseReleaseEvent(QMouseEvent*event);
    QPoint dragPosition;

    void closeEvent(QCloseEvent *);

    void createACtion();
    void createContextMenu();

    int WidgetWidth;
    int WidgetHeight;

    int ScreenWidth;
    int ScreenHeight;

    int startX;
    int startY;

    QAction *WhiteAction;
    QAction *GreenAction;
    QAction *PinkAction;
    QAction *YellowAction;

    QString color;

    int TopTempWidth;
    int TopTempHeight;




private slots:
    void settransparent(int);
    void textChanged();
    void contextMenuEvent(QContextMenuEvent *);

    void setcolorGreen();
    void setcolorPink();
    void setcolorYellow();
    void setcolorWhite();

    void topClicked();


    //void on_textEdit_customContextMenuRequested(const QPoint &pos);
};

#endif // WIDGET_H
